org.apache.tomcat.util.modeler

## Interface RegistryMBean

- All Known Implementing Classes:
    Registry

      public interface RegistryMBean

  Interface for modeler MBeans. This is the main entry point into modeler. It provides methods to create and manipulate model mbeans and simplify their use. Starting with version 1.1, this is no longer a singleton and the static methods are strongly deprecated. In a container environment we can expect different applications to use different registries.
  Since:
    1.1
  Author:
    Craig R. McClanahan, Costin Manolache

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getId(String domain, String name)` Return an int ID for faster access.
    `void` | `invoke(List<ObjectName> mbeans, String operation, boolean failFirst)` Invoke an operation on a set of mbeans.
    `void` | `registerComponent(Object bean, String oname, String type)` Register a bean by creating a modeler mbean and adding it to the MBeanServer.
    `void` | `stop()` Reset all metadata cached by this registry.
    `void` | `unregisterComponent(String oname)` Unregister a component.

- - ### Method Detail

    - #### invoke

          void invoke(List<ObjectName> mbeans,
                    String operation,
                    boolean failFirst)
                      throws Exception

      Invoke an operation on a set of mbeans.
      Parameters:
        `mbeans` - List of ObjectNames
        `operation` - Operation to perform. Typically "init" "start" "stop" or "destroy"
        `failFirst` - Behavior in case of exceptions - if false we'll ignore errors
      Throws:
        `Exception` - Error invoking operation

    - #### registerComponent

          void registerComponent(Object bean,
                               String oname,
                               String type)
                                 throws Exception

      Register a bean by creating a modeler mbean and adding it to the MBeanServer. If metadata is not loaded, we'll look up and read a file named "mbeans-descriptors.ser" or "mbeans-descriptors.xml" in the same package or parent. If the bean is an instance of DynamicMBean. it's metadata will be converted to a model mbean and we'll wrap it - so modeler services will be supported If the metadata is still not found, introspection will be used to extract it automatically. If an mbean is already registered under this name, it'll be first unregistered. If the component implements MBeanRegistration, the methods will be called. If the method has a method "setRegistry" that takes a RegistryMBean as parameter, it'll be called with the current registry.
      Parameters:
        `bean` - Object to be registered
        `oname` - Name used for registration
        `type` - The type of the mbean, as declared in mbeans-descriptors. If null, the name of the class will be used. This can be used as a hint or by subclasses.
      Throws:
        `Exception` - Error registering MBean
      Since:
        1.1

    - #### unregisterComponent

          void unregisterComponent(String oname)

      Unregister a component. We'll first check if it is registered, and mask all errors. This is mostly a helper.
      Parameters:
        `oname` - The name used by the bean
      Since:
        1.1

    - #### getId

          int getId(String domain,
                  String name)

      Return an int ID for faster access. Will be used for notifications and for other operations we want to optimize.
      Parameters:
        `domain` - Namespace
        `name` - Type of the notification
      Returns:
        A unique id for the domain:name combination
      Since:
        1.1

    - #### stop

          void stop()

      Reset all metadata cached by this registry. Should be called to support reloading. Existing mbeans will not be affected or modified. It will be called automatically if the Registry is unregistered.
      Since:
        1.1

Copyright © 2000-2021 Apache Software Foundation. All Rights Reserved.